<?php 
# 
# Mike Robinson	 
# London UK 
# 2008-OCT-18 
# Generate analysis on MySQL databases 
# Get latest copy from http://www.checkmypages.com/mysql_check 
# 
# 
session_start(); 
$time_started=time(); 
$run_slow = 0; 
start_html( ); 
$prog="check_db.php"; 
$matching = ""; 
$failed = 0; 
$db = get_param( "db" ); 
$db_part=$db; 
if ( isset( $_GET["db_server"] ) or isset( $_POST["db_server"] ) ) { 
$db_server = get_param( "db_server" ); 
$db_user = get_param( "db_user" ); 
$db_pwd = get_param( "db_pwd" ); 
$_SESSION[ "db_server" ] = $db_server; 
$_SESSION[ "db_user" ] = $db_user; 
$_SESSION[ "db_pwd" ] = $db_pwd; 
} 
#DEMO_SETTINGS 
if ( get_session( "db_user" ) > "" ) { 
$db_server = get_session( "db_server" ); 
$db_user = get_session( "db_user" ); 
$db_pwd = get_session( "db_pwd" ); 
} 
$tmp = explode( ':',$db ); 
if ( ereg( ':', $db ) ) { 
$db_part = $tmp[0]; 
$matching = $tmp[1]; 
$run_slow = $tmp[2]; 
$mode = $tmp[2]; 
}  
if ( $db_user > "" ) { 
mysql_pconnect("$db_server","$db_user","$db_pwd") or $failed = 1; 
} 
if ( $db_server == "" or $failed ) { 
show_title( ); 
echo "<form action=$prog method=post> 
<p><font size=+2> 
Enter MySQL connection details :<p> 
<table> 
<tr><td>&nbsp; &nbsp; &nbsp; Server</td><td><input type=text name=db_server value=localhost> 
</td></tr> 
<tr><td>&nbsp; &nbsp; &nbsp; User name</td><td><input type=text name=db_user value=></td></tr> 
<tr><td>&nbsp; &nbsp; &nbsp; Password</td><td><input type=password name=db_pwd value=></td></tr> 
</table>"; 
echo	"<br> &nbsp; &nbsp;  &nbsp; &nbsp;  &nbsp; &nbsp; <input type=submit value=Go> 
</form>\n"; 
if ( $failed ) { 
echo "<center><font color=red>Failed to connect</font></center>\n"; 
} 
end_html( ); 
exit; 
} 
$tab = get_param( 'tab' ); 
$col = get_param( 'col' ); 
$mode = get_param( 'mode' ); 
$action = get_param( 'action' ); 
#DEMO_SETTINGS 
if ( $db == "" ) { 
show_title( ); 
$sql = "show databases"; 
$result = run_sql( $sql ); 
echo "<form action=$prog method=post> 
<font size=+2><p>Pick a database :<br>\n"; 
while( list( $name ) = mysql_fetch_row( $result ) ) { 
if ( $name != 'information_schema' ) { 
$tmp = "$name::0"; 
echo "<br> &nbsp; &nbsp; &nbsp; <input type=radio name=db value='$tmp'>$name\n"; 
} 
} 
echo	"<br> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <input type=submit name=Go value=Go></font> 
</form>\n"; 
end_html( ); 
exit; 
} 
mysql_select_db($db_part) or die("Could not connect to your database :<br> &nbsp; db=$db_part"); 
$sql = "create temporary table if not exists chkdb_out( 
table_name	varchar(50), 
field_name	varchar(50), 
priority	int, 
seq		int, 
txt		varchar(250) 
) "; 
$result = run_sql( $sql ); 
$sql = "create table if not exists chkdb_tmp( 
str_val1	varchar(250), 
str_val2	varchar(250), 
int_val		int, 
str_val3	varchar(250), 
str_val4	varchar(250)  
) "; 
$result = run_sql( $sql ); 
$sql = "create table if not exists chkdb_tabs( 
table_name	varchar(50), 
table_rows	int 
) 
select  t.table_name, t.table_rows 
from	information_schema.TABLES t 
where   t.table_schema = schema() 
and t.table_name like '$matching%' 
and t.table_name not like 'chkdb_%' 
and t.table_type = 'BASE TABLE' "; 
$result = run_sql( $sql ); 
$sql = "create table if not exists chkdb_fields( 
table_name	varchar(50), 
column_name	varchar(50),  
field_type	varchar(30) 
) 
select  t.table_name, c.column_name, 
concat( replace(c.COLUMN_TYPE,'int(11)','int'), if( c.IS_NULLABLE='YES', ' NULL','' ) )  
as field_type 
from	information_schema.TABLES t, 
information_schema.COLUMNS  c 
where   t.table_schema = schema() 
and t.table_type = 'BASE TABLE' 
and t.table_name like '$matching%' 
and t.table_name not like 'chkdb_%' 
and c.table_schema = schema() 
and c.table_name = t.table_name "; 
$result = run_sql( $sql ); 
$sql = "create table if not exists chkdb_idxs( 
table_name	varchar(50), 
index_name	varchar(50), 
non_unique	boolean, 
seq_in_index	int, 
field_name	varchar(50), 
nullable	varchar(3) 
) 
select	s.table_name, s.index_name, s.non_unique, s.seq_in_index,  
s.column_name as field_name, s.nullable 
from	information_schema.TABLES t, 
information_schema.STATISTICS s 
where   t.table_schema = schema() 
and t.table_type = 'BASE TABLE' 
and t.table_name like '$matching%' 
and t.table_name not like 'chkdb_%' 
and s.table_schema = schema() 
and s.table_name = t.table_name "; 
$result = run_sql( $sql ); 
if ( $run_slow == "" ) { 
$sql = "delete from chkdb_tmp"; 
$result = run_sql( $sql ); 
for( $c=6; $c>=2 ;$c -- ) { 
$sql = "insert chkdb_tmp ( str_val1, str_val2, int_val, str_val3 ) 
select  substr( table_name,1,$c ) as fixing, 
NULL, 
( count(*) * 100 ) / (  
select	count(*) 
from	chkdb_tabs ) as pct, 
NULL 
from    chkdb_tabs  
group by fixing 
having pct > 10 
and count(*) > 5 
and not exists ( select 1 from chkdb_tmp t  
where t.str_val1 like concat( fixing,'%' )) "; 
$result = run_sql( $sql ); 
} 
show_title( ); 
$sql = "select	str_val1, str_val1 as name 
from    chkdb_tmp  
order by name"; 
$result = run_sql( $sql ); 
echo "<form action=$prog method=post> 
<p><font size=+2> 
Do you want to examine :\n 
<p> &nbsp; &nbsp; &nbsp; <input type=radio name=db checked value=$db:>All items in the database"; 
while( list( $fix,$name ) = mysql_fetch_row( $result ) ) { 
echo "<br> &nbsp; &nbsp; &nbsp; <input type=radio name=db value=$db_part:$fix:0>only items starting 
<font color=green>$fix</font>\n"; 
} 
echo	"<br> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <input type=submit value=Go> 
</form>\n"; 
end_html( ); 
exit; 
} 
if ( $tab > "" ) { 
show_title( ); 
$sql = "select count(*) from $tab"; 
$result = run_sql( $sql ); 
list( $rows ) = mysql_fetch_row( $result ); 
$sql = "show create table $tab"; 
$result = run_sql( $sql ); 
list( $name, $code ) = mysql_fetch_row( $result ); 
echo "<br><font size=+2>Table create statement :</font><br> 
<center><table><tr><td><pre>$code</pre></td></tr></table></center>"; 
echo "</center>\n"; 
end_html( ); 
exit; 
} 
if ( $col > "" ) { 
show_title( ); 
$sql = "select  distinct t.table_name, 
c.column_name, 
concat( c.COLUMN_TYPE, if( c.IS_NULLABLE='YES', ' NULL','' ) ) as col_type 
from    information_schema.COLUMNS  c, 
information_schema.TABLES t 
where   c.table_schema = schema() 
and t.table_schema = schema() 
and t.table_type = 'BASE TABLE' 
and c.table_name = t.table_name 
and (	c.column_name = '$col' 
or trim( trailing 's' from lower(replace( c.column_name,'_',''))) = '$col' ) "; 
echo "<br><font size=+2>The following columns match $col :</font><ul>"; 
$result = run_sql( $sql ); 
while( list( $tab, $col, $def ) = mysql_fetch_row( $result ) ) { 
echo "   <li>Table <a href=$prog?db=$db&tab=$tab>$tab</a> 
has column <a href=$prog?db=$db&col=$col>$col</a> 
defined as $def\n"; 
} 
echo "</ul>\n"; 
end_html( ); 
exit; 
} 
$str = get_param( 'str' ); 
if ( $str > "" ) { 
} 
##################### 
##################### 
$sql = "show databases"; 
$result = run_sql( $sql ); 
$c = 0; 
while( list( $name ) = mysql_fetch_row( $result ) ) { 
$c ++; 
} 
if ( $c > 10 ) { 
$sql = "insert chkdb_out  
values ( ' General', '', 30,0, 
'There are $c databases on this server' ) "; 
$result = run_sql( $sql ); 
} 
$sql = "insert chkdb_out  
select	' General', '', 20,0, 
'There are no user tables in this database' 
from	dual 
where	( select count(*) from	chkdb_tabs ) = 0 "; 
$result = run_sql( $sql ); 
$sql = "select	count(*) 
from	chkdb_tabs 
where	lower(table_name) like '%s'"; 
$result = run_sql( $sql ); 
list( $plural ) = mysql_fetch_row( $result ); 
$sql = "select	count(*) 
from	chkdb_tabs 
where	lower(table_name) not like '%s'"; 
$result = run_sql( $sql ); 
list( $single ) = mysql_fetch_row( $result ); 
if ( 	( $single * 100 ) / ($plural + $single) >= 75  
and $plural > 0 ) { 
$sql = "insert chkdb_out  
select	t.table_name, '', 50,table_rows, 
'This table has a plural name while most table names are singular' 
from	chkdb_tabs t 
where	lower(table_name) like '%s'"; 
$result = run_sql( $sql ); 
} 
if ( 	( $plural * 100 ) / ($plural + $single) >= 75  
and $single > 0 ) { 
$sql = "insert chkdb_out  
select	t.table_name, '', 50,table_rows, 
'This table has a singlular name while most table names are plural' 
from	chkdb_tabs t 
where	lower(table_name) not like '%s'"; 
$result = run_sql( $sql ); 
} 
$sql = "insert chkdb_out  
select	t.table_name, '', 
20,table_rows, 
concat( 'Table has ', table_rows, ' rows' ) 
from    chkdb_tabs t 
where   table_rows > 1000000  
order by t.table_rows desc 
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	t.table_name, '', 30,table_rows, 
'This table is not referenced by your stored procedures' 
from	chkdb_tabs t 
where	$run_slow = 1 
and not exists( 
select  1 
from    information_schema.ROUTINES r 
where   r.ROUTINE_SCHEMA=schema() 
and (	ROUTINE_DEFINITION regexp concat('from *',t.table_name) 
or ROUTINE_DEFINITION regexp concat(', *',t.table_name) ) ) "; 
#and ROUTINE_DEFINITION like concat('%',t.table_name,'%') )  
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	t.table_name, '', 10,table_rows, 
'This table has no indexes'  
from	chkdb_tabs t 
where	table_name not in ( 
SELECT   table_name 
FROM     chkdb_idxs ) 
order by table_rows desc 
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out 
select	distinct t.table_name, '', 20,table_rows, 
'This table has no unique index' 
from    chkdb_tabs t 
where	table_name not in ( 
select	table_name 
from	chkdb_idxs 
where	non_unique=0 ) 
and t.table_name in ( 
select	table_name 
from	chkdb_idxs ) 
order by table_rows desc 
limit 10 "; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	t.table_name, '', 35,table_rows, 
'This table has no primary key' 
from    chkdb_tabs t 
where	t.table_name not in ( 
select	table_name 
from	chkdb_idxs 
where	index_name = 'PRIMARY' ) 
order by table_rows desc 
limit 10 "; 
$result = run_sql( $sql ); 
$sql = "select	t.table_name 
from    chkdb_tabs t 
where   $run_slow = 1 
and table_name not in ( 
select	table_name 
from	chkdb_idxs 
where	non_unique = 0 ) 
and t.table_rows between 2 and 1000000 "; 
$result = run_sql( $sql ); 
while( list( $tab ) = mysql_fetch_row( $result ) ) { 
$sql2 = "select count(*) from $tab "; 
$result2 = run_sql( $sql2 ); 
list( $cnta ) = mysql_fetch_row( $result2 ); 
$sql2 = "select count(*) from ( select distinct * from $tab ) xxx "; 
$result2 = run_sql( $sql2 ); 
list( $cntb ) = mysql_fetch_row( $result2 ); 
$diff = ( $cnta - $cntb ) + 1; 
if ( $cnta != $cntb ) { 
$sql2 = "insert chkdb_out 
values ('$tab', '', 5,$diff, 
'Table has $diff sets of duplicate rows' )"; 
$result2 = run_sql( $sql2 ); 
list( $cntb ) = mysql_fetch_row( $result2 ); 
} 
} 
$sql = "insert chkdb_out  
select	' General','', 40,0, 
concat( 'MySQL version ', version(), ' is no longer current' ) 
from	dual 
where	version() < '5' "; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	i.table_name, '', 20,0, 
concat( 'The unique index <font color=green>', i.index_name,  
'</font> contains the nullable columns (=col,', group_concat( i.field_name ), ')' ) 
from    chkdb_tabs t, 
chkdb_idxs i 
where	i.table_name = t.table_name 
and i.nullable = 'YES' 
and i.non_unique = 0 
group by i.index_name, i.table_name  
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	i.table_name, '', 80,0, 
concat( 'The index <font color=green>', i.index_name,  
'</font> contains the nullable columns (=col,', group_concat( i.field_name ), ')' ) 
from    chkdb_tabs t, 
chkdb_idxs i 
where	i.table_name = t.table_name 
and i.nullable = 'YES' 
and i.non_unique = 1 
group by i.index_name, i.table_name  
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct t.table_name,'', 20,0, 
concat( 'The indexes (=null,',  
group_concat( distinct s2.index_name ), ') cover the same fields' ) 
from    chkdb_idxs s1, 
chkdb_idxs s2, 
chkdb_tabs t 
where	s1.table_name = t.table_name 
and s2.table_name = s1.table_name 
and s2.index_name != s1.index_name 
and s1.seq_in_index = 2 
and not exists( 
select  1 
from	chkdb_idxs s3 
where   s3.table_name = s2.table_name 
and s3.index_name = s2.index_name 
and s3.field_name not in ( 
select  s4.field_name 
from    chkdb_idxs s4 
where   s4.table_name = s1.table_name 
and s4.index_name = s1.index_name ) )  
group by t.table_name 
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct t1.table_name, '', 40,t1.table_rows, 
concat( 'Different compound index order to table <a href=$prog?db=$db&tab=', s2.table_name,  
'>', s2.table_name, '</a>' ) 
from    chkdb_idxs s1, 
chkdb_idxs s2, 
chkdb_tabs t1, 
chkdb_tabs t2 
where   t1.table_name != t2.table_name 
and s1.table_name = t1.table_name 
and s2.table_name = t2.table_name 
and s1.seq_in_index = 2 
and s2.seq_in_index = 2 
and not exists( 
select  1 
from    chkdb_idxs s3 
where   s3.table_name = s1.table_name 
and s3.index_name = s1.index_name 
and s3.field_name not in ( 
select	s4.field_name 
from	chkdb_idxs s4 
where	s4.table_name = s2.table_name 
and s4.index_name = s2.index_name ) ) 
and exists( 
select  1 
from    chkdb_idxs s3, 
chkdb_idxs s4 
where   s3.table_name = s1.table_name 
and s4.table_name = s2.table_name 
and s3.index_name = s1.index_name 
and s4.index_name = s2.index_name 
and s3.field_name = s4.field_name 
and s3.seq_in_index != s4.seq_in_index ) "; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct table_name, '', 40,0, 
concat( 'This table has ', count(distinct index_name), ' indexes!' ) 
from    chkdb_idxs 
group by table_name 
having count( distinct index_name ) > 3 "; 
$result = run_sql( $sql ); 
$sql = "delete from chkdb_tmp"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_tmp ( str_val1, str_val2, int_val, str_val3 ) 
select  c.column_name, 
c.field_type, 
count(*), 
null 
from    chkdb_fields c 
group by c.column_name,c.field_type "; 
$result = run_sql( $sql ); 
$sql = "update	chkdb_tmp 
set	str_val3 = ( 
select	field_type 
from    chkdb_fields c 
where	c.column_name = chkdb_tmp.str_val1 
group by c.field_type 
having count(*) > 4 
order by count(*) desc 
limit 1 ) "; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct f.table_name, f.column_name, 20,0, 
concat( 'Column <a href=$prog?db=$db&col=', f.column_name,'>',f.column_name, 
'</a> is defined as <font color=green>', t.str_val2,  
'</font> while normally defined as <font color=green>', t.str_val3,  
'</font>' )  
from    chkdb_fields f, 
chkdb_tmp t 
where	t.str_val2 != t.str_val3 
and t.str_val3 > '' 
and t.str_val1 = f.column_name  
and f.field_type = t.str_val2 "; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	t.table_name, '', 30,table_rows, 
'Is this table required?' 
from	chkdb_tabs t 
where	table_name like '%tmp%' 
or ( table_name like '%temp%' and table_name not like '%systemp%' ) 
or table_name like '%bak%' 
or table_name like '%backup%' 
or table_name like '%copy%' 
or table_name like '%old%' 
or table_name regexp '[0-9][0-9][0-9][0-9][0-9][0-9]' 
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out 
select	distinct t.table_name, '', 40,t.table_rows, 
concat(  
'Should the fields ' , 
'<a href=$prog?db=$db&col=', c.column_name, '>', c.column_name, '</a>', 
', ',  
'<a href=$prog?db=$db&col=', c2.column_name, '>', c2.column_name, '</a>', 
' ... be moved into a separate table?' ) 
from	chkdb_tabs t, 
chkdb_fields c, 
chkdb_fields c2 
where	c.table_name = t.table_name 
and (   c.column_name like '%1%' 
or c.column_name like '%jan%' ) 
and c2.table_name = t.table_name 
and c2.column_name != c.column_name 
and (   c2.column_name like '%2%' 
or c2.column_name like '%feb%' )  
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct t.table_name, '', 40,count(*), 
concat( 'This table has a similar name to (=tab,', group_concat( distinct t.table_name ), ')' ) 
from	chkdb_tabs t 
group by trim( trailing 's' from lower(replace( t.table_name,'_',''))) 
having count(distinct t.table_name) > 1  
limit 10"; 
$result = run_sql( $sql ); 
$sql = "delete from chkdb_tmp"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_tmp ( str_val1, str_val2, int_val, str_val3 ) 
select  trim( trailing 's' from lower(replace( c.column_name,'_',''))) as name, 
concat( 'Column names (=col,', group_concat( distinct c.column_name ),  
') should perhaps be standardised' ), 
NULL,NULL 
from	chkdb_fields c 
group by name 
having count(distinct c.column_name) > 1  
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out 
select	distinct c.table_name, c.column_name, 50,0, 
t.str_val2 
from	chkdb_fields c, 
chkdb_tmp t 
where	trim( trailing 's' from lower(replace( c.column_name,'_',''))) = t.str_val1 
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct t.table_name, '', 70,0, 
'the naming of this table is poor' 
from    chkdb_tabs t 
where   lower( t.table_name ) like 'tab_%' 
or lower( t.table_name ) like 'table_%' 
or lower( t.table_name ) like '%_table' 
or lower( t.table_name ) like '%_tab' 
limit 10"; 
$result = run_sql( $sql ); 
$start_date = date('Y-m-d', strtotime("-3 months")); 
$end_date = date('Y-m-d', strtotime("3 months")); 
$sql = "select	concat( t.table_name, '=', group_concat( c.column_name ) ) 
from    chkdb_tabs t, 
chkdb_fields c 
where   c.table_name = t.table_name 
and c.field_type like '%datetime%' 
and t.table_rows > 0 
group by t.table_name "; 
$result = run_sql( $sql ); 
while( list( $str ) = mysql_fetch_row( $result ) ) { 
$tab = ereg_replace( '=.*$', '', $str ); 
$cols = explode( ',', ereg_replace( '^.*=', '', $str ) ); 
$sql2 = "insert chkdb_out  
select	distinct '$tab', '', 20,0, 
'Table only seems to contain old data' 
from dual 
where 1 = 1"; 
foreach( $cols as $col ) { 
$sql2 .= " and not exists( select 1 from $tab " . 
"where $col between '$start_date' and '$end_date') "; 
} 
$result2 = run_sql( $sql2 ); 
} 
$sql = "delete from chkdb_tmp"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_tmp ( str_val1, str_val2, int_val, str_val3 ) 
select  distinct table_name, NULL, NULL, 'Table' 
from    chkdb_tabs "; 
$result = run_sql( $sql ); 
check_naming( 'Table' ); 
$sql = "delete from chkdb_tmp"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_tmp ( str_val1, str_val2, int_val, str_val3, str_val4 ) 
select  distinct column_name, NULL, NULL, 'Field', table_name 
from    chkdb_fields "; 
$result = run_sql( $sql ); 
check_naming( 'Field' ); 
$sql = "delete from chkdb_tmp"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_tmp ( str_val1, str_val2, int_val, str_val3 ) 
select  distinct routine_name, NULL, NULL, 'Stored procedure' 
from    information_schema.ROUTINES 
where	routine_schema = schema() 
and routine_name like '$matching%' "; 
$result = run_sql( $sql ); 
check_naming( 'Stored procedure' ); 
/* 
$sql = "insert chkdb_out  
select	distinct table_name, '', 100,0, 
concat( 'Recommend :<i>drop table ', table_name, '</i>') 
from    chkdb_tabs t 
where	exists( 
select	1 
from	chkdb_out o 
where	o.table_name = t.table_name 
and txt like '%no indexes%' ) 
and exists( 
select	1 
from	chkdb_out o 
where	o.table_name = t.table_name 
and txt like '%prefix%' ) 
and exists( 
select	1 
from	chkdb_out o 
where	o.table_name = t.table_name 
and txt like '%not referenced%' ) "; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct  table_name, '', 100,0, 
concat( 'Recommend :<i>alter table ', table_name, ' add primary key (', 
( select group_concat( field_name order by seq_in_index ) 
from	chkdb_idxs i 
where	i.table_name = t.table_name 
and non_unique = 0 
and i.index_name not in ( 
select	i2.index_name 
from	chkdb_idxs i2 
where	i2.table_name = t.table_name 
and i2.non_unique = 0 
and i2.nullable = 'YES' ) 
group by i.index_name 
limit 1 ), 
')</i>') 
from    chkdb_tabs t 
where	exists( 
select	1 
from	chkdb_out o 
where	o.table_name = t.table_name 
and txt like '%no primary%' ) 
and not exists( 
select	1 
from	chkdb_out o 
where	o.table_name = t.table_name 
and txt like '%no indexes%' ) 
and not exists( 
select	1 
from	chkdb_out o 
where	o.table_name = t.table_name 
and txt like '%no unique index%' ) 
and ( select group_concat( field_name order by seq_in_index ) 
from	chkdb_idxs i 
where	i.table_name = t.table_name 
and non_unique = 0 
and i.index_name not in ( 
select	i2.index_name 
from	chkdb_idxs i2 
where	i2.table_name = t.table_name 
and i2.non_unique = 0 
and i2.nullable = 'YES' ) 
group by i.index_name 
limit 1 ) > '' "; 
$result = run_sql( $sql ); 
*/ 
$sql = "insert chkdb_out  
select	distinct ' General', '', 80,0, 
concat( 'Stored procedure <font color=green>', routine_name, '</font> contains cursors' ) 
from	information_schema.ROUTINES 
where	routine_schema = schema() 
and routine_name like '$matching%' 
and ROUTINE_DEFINITION regexp 'fetch *[a-zA-Z0-9]+ *into ' 
limit 10"; 
$result = run_sql( $sql ); 
$sql = "insert chkdb_out  
select	distinct ' General', '', 95,0, 
concat( 'Stored procedure <font color=green>', routine_name, '</font> is recursive' ) 
from	information_schema.ROUTINES 
where	routine_schema = schema() 
and routine_name like '$matching%' 
and ROUTINE_DEFINITION regexp concat( 'call *', routine_name ) 
limit 10"; 
$result = run_sql( $sql ); 
$sql = "select now()"; 
$result = run_sql( $sql ); 
list( $time ) = mysql_fetch_row( $result ); 
$min_diff = abs( strtotime( $time ) - time() ) / 60; 
if ( $min_diff >= 5 ) { 
$sql = "insert chkdb_out  
select	distinct ' General', '', 30,0, 
'MySQL and UNIX time are out by $min_diff minutes' 
from	dual "; 
$result = run_sql( $sql ); 
} 
$sql = "insert chkdb_out  
select	distinct t.table_name, '', 70,0, 
concat( 'Field <a href=$prog?db=$db&col=', c.column_name, '>', c.column_name,  
'</a> could have a foreign key against table <a href=$prog?db=$db&tab=',  
(	select	s2.table_name 
from	chkdb_tabs t2, 
chkdb_idxs s2 
where	s2.table_name = t2.table_name 
and s2.NON_UNIQUE = 0 
and t2.table_name != t.table_name 
group by s2.table_name , s2.index_name 
having	count(*) = 1 
and group_concat(s2.field_name) = c.column_name 
limit 1 
), '>', 
(	select	s2.table_name 
from	chkdb_tabs t2, 
chkdb_idxs s2 
where	s2.table_name = t2.table_name 
and s2.NON_UNIQUE = 0 
and t2.table_name != t.table_name 
group by s2.table_name , s2.index_name 
having	count(*) = 1 
and group_concat(s2.field_name) = c.column_name 
limit 1 
), '</a> ( ', c.column_name, ' )' ) 
from	chkdb_tabs t, 
chkdb_fields c 
where	c.table_name = t.table_name 
and not exists(  
select	1 
from	chkdb_tabs t2, 
chkdb_idxs s2 
where	s2.table_name = t2.table_name 
and s2.NON_UNIQUE = 0 
and t2.table_name = t.table_name 
group by s2.table_name , s2.index_name 
having	count(*) = 1 
and group_concat(s2.field_name) = c.column_name ) 
and exists(  
select	1 
from	chkdb_tabs t2, 
chkdb_idxs s2 
where	s2.table_name = t2.table_name 
and s2.NON_UNIQUE = 0 
and t2.table_name != t.table_name 
group by s2.table_name , s2.index_name 
having	count(*) = 1 
and group_concat(s2.field_name) = c.column_name 
)  
and not exists( 
select	1 
from	information_schema.KEY_COLUMN_USAGE k 
where	k.table_name = t.table_name 
and k.column_name = c.column_name ) "; 
#referenced_table_name 
#referenced_column_name 
$result = run_sql( $sql ); 
################# 
################# 
show_title( ); 
$sql = "select	table_name, txt, priority, field_name 
from	(	select table_name, txt, priority, seq, field_name 
from	chkdb_out 
order by priority 
limit 100 ) xxx 
order by table_name, priority, seq + 0 desc "; 
$result = run_sql( $sql ); 
$old_table = ''; 
while( list( $table, $txt, $priority, $col ) = mysql_fetch_row( $result ) ) { 
if ( $table != $old_table and $old_table > '' ) { 
echo "</ul>\n"; 
} 
if ( $table != $old_table ) { 
$sql = "select table_rows from chkdb_tabs where table_name='$table' "; 
$result2 = run_sql( $sql ); 
list( $rows ) = mysql_fetch_row( $result2 ); 
if ( $table != ' General' ) { 
echo "<p><h3>Table <a href=$prog?db=$db&tab=$table>$table</a> has $rows rows</h3><ul>\n"; 
} else { 
echo "<p><h3>General points</h3><ul>\n"; 
} 
$old_table = $table; 
} 
echo "<li>"; 
if ( $priority <= 10 ) { 
echo "<font color=red>" . show_list( $txt ) . "</font>\n"; 
} elseif ( $priority <= 30 ) { 
echo "<font color=purple>" . show_list( $txt ) . "</font>\n"; 
} else { 
echo show_list( $txt ) . "\n"; 
} 
} 
echo "</ul>\n"; 
end_html( ); 
exit; 
function check_naming( $type ) { 
for( $c=6; $c>=2 ;$c -- ) { 
$sql = "insert chkdb_tmp ( str_val1, str_val2, int_val, str_val3 ) 
select  substr( str_val1,1,$c ) as fixing, 
NULL, 
( count(*) * 100 ) / (  
select	count(*) 
from	chkdb_tmp 
where	str_val3 = '$type' ) as pct, 
'prefix' 
from    chkdb_tmp 
where	substr( str_val1,1,$c ) like '%\_' 
group by fixing 
having pct > 10 
and count(*) > 5 
and not exists (  
select	1  
from	chkdb_tmp t  
where	str_val3 = 'prefix'  
and t.str_val1 like concat( fixing,'%' )) "; 
$result = run_sql( $sql ); 
} 
if ( $type == 'Table' ) { 
$sql = "insert chkdb_out  
select	distinct str_val1, '', 50,0, 
concat( '$type names normally have the prefix (=null,', 
( select concat( 'or,', group_concat( str_val1 ) ) 
from chkdb_tmp where str_val3 = 'prefix' ), ')' ) 
from    chkdb_tmp t 
where	str_val3 = '$type' 
and not exists (  
select	1  
from	chkdb_tmp t2 
where	t2.str_val3 = 'prefix' 
and t.str_val1 like concat( t2.str_val1,'%' ) ) "; 
} elseif ( $type == 'Field' ) { 
$sql = "insert chkdb_out  
select	distinct str_val4, '', 50,0, 
concat( '$type ', str_val1, ' should have the prefix (=null,', 
( select concat( 'or,', group_concat( str_val1 ) ) 
from chkdb_tmp where str_val3 = 'prefix' ), ')' ) 
from    chkdb_tmp t 
where	1 = 0 
and str_val3 = '$type' 
and not exists (  
select	1  
from	chkdb_tmp t2 
where	t2.str_val3 = 'prefix' 
and t.str_val1 like concat( t2.str_val1,'%' ) ) "; 
} else { 
$sql = "insert chkdb_out  
select	distinct ' General', '', 70,0, 
concat( '$type ', str_val1, ' does not have the prefix (=null,', 
( select concat( 'or,', group_concat( str_val1 ) ) 
from chkdb_tmp where str_val3 = 'prefix' ), ')' ) 
from    chkdb_tmp t 
where	str_val3 = '$type' 
and not exists (  
select	1  
from	chkdb_tmp t2 
where	t2.str_val3 = 'prefix' 
and t.str_val1 like concat( t2.str_val1,'%' ) ) "; 
} 
$result = run_sql( $sql ); 
$sql = "update chkdb_tmp  
set	str_val2 = concat( 'initially ', 
if( binary str_val1 rlike '^[A-Z][A-Z]', 'uppercase', 
if ( binary str_val1 rlike '^[A-Z][a-z]%', 'capitalised', 'lowercase' ) ), 
if( binary str_val1 like '%\_%', ' with underscore', '' ), 
' and then', 
if( binary str_val1 not rlike '[a-z]', ' uppercase', 
if ( binary str_val1 rlike '^...*[A-Z]', ' capitalised', ' lowercase' ) ) ) 
where	str_val3 = '$type' "; 
$result = run_sql( $sql ); 
$sql = "select	str_val2, 
( count(*) * 100 ) / (  
select	count(*)  
from	chkdb_tmp  
where	str_val3 = '$type' ) as pct 
from	chkdb_tmp 
where	str_val3 = '$type' 
group by str_val2 
order by pct desc 
limit 1 "; 
$result = run_sql( $sql ); 
list( $style, $pct ) = mysql_fetch_row( $result ); 
if ( $type == 'Table' ) { 
$sql = "insert chkdb_out  
select	distinct str_val1, '', 90,0, 
'$type naming style is usually <font color=green>$style</font>' 
from	chkdb_tmp 
where	0$pct > 50 
and str_val2 != '$style' "; 
} elseif ( $type == 'Field' ) { 
$sql = "insert chkdb_out  
select	distinct ' General', '', 90,0, 
concat( '$type ', str_val1,  
' naming style is usually <font color=green>$style</font>' ) 
from	chkdb_tmp 
where	1 = 0 "; 
} else { 
$sql = "insert chkdb_out  
select	distinct ' General', '', 90,0, 
concat( '$type ', str_val1,  
' naming style is usually <font color=green>$style</font>' ) 
from	chkdb_tmp 
where	0$pct > 50 
and str_val2 != '$style' "; 
} 
$result = run_sql( $sql ); 
if ( $pct > 0 and $pct <= 50 ) { 
$sql = "insert chkdb_out  
values (' General', '', 10,0, 
concat( 'Your ', lower('$type'),  
' naming follows no set pattern' ) ) "; 
$result = run_sql( $sql ); 
} 
} 
function show_list( $in_str ) { 
GLOBAL $db; 
$str = ''; 
$join = ' and '; 
if ( ! ereg( '[(]=',$in_str ) ) { 
return $in_str; 
} else { 
$str = ereg_replace( '[(].*',' ',$in_str ); 
$tmp = ereg_replace( '^[^(]*[(]','',$in_str ); 
$tmp = ereg_replace( '[)].*$','',$tmp ); 
$end_str = ereg_replace( '^.*[)]','',$in_str ); 
$vals = explode(',',$tmp); 
$column=ereg_replace( '=','',array_shift( $vals ) ); 
if ( $vals[0] == 'or' ) {  
$join = ' or ';  
array_shift( $vals ); 
} 
$cnt = count( $vals ); 
$c = 0; 
foreach( $vals as $p ) { 
$c ++; 
if ( $column != 'null' ) { 
$str .= "<a href=$prog?db=$db&$column=$p>$p</a>"; 
} else { 
$str .= "<font color=green>$p</font>"; 
} 
if ( $c == $cnt -1 ) { 
$str .= $join; 
} elseif ( $c < $cnt ) { 
$str .= " , &nbsp; "; 
} 
} 
$str .= $end_str; 
return $str; 
} 
} 
function get_param( $param ) { 
if ( isset( $_POST["$param"] ) ) { 
$tmp = $_POST["$param"]; 
} else { 
$tmp = $_GET["$param"]; 
} 
$tmp = ereg_replace( '[;\'"]', '', $tmp ); 
return( $tmp ); 
} 
function run_sql( $sql ) { 
GLOBAL $db; 
GLOBAL $db_user; 
$sql = ereg_replace( "[".chr(0x01)."-".chr(0x1F)."]", " ", $sql ); 
$sql = ereg_replace( "[ \t]+", " ", $sql ); 
$fail = 0; 
$start_t = time(); 
$result=mysql_query( $sql ) or $fail = 1; 
$end_t = time(); 
if ( $fail ) { 
echo "<br><font color=red>Problem with SQL: $sql</font><font color=green>" .  
mysql_error() . "</font><br>\n"; 
} 
if ( $end_t - $start_t > 15 ) { 
echo "<font color=red>Query $sql took " . ($end_t - $start_t) . " secs</font><br>\n"; 
} 
return $result; 
} 
function end_html( ) { 
GLOBAL $db_user; 
echo	"</td></tr><tr><td align=right> 
<br><br>by <a href=http://www.bikesandkites.com><font size=-2>Mike Robinson</font></a> 
</td></tr></table></center></body></html>\n"; 
if ( $db_user > "" ) { 
$sql = "drop table if exists chkdb_out "; 
$result = run_sql( $sql ); 
$sql = "drop table if exists chkdb_tabs "; 
$result = run_sql( $sql ); 
$sql = "drop table if exists chkdb_fields "; 
$result = run_sql( $sql ); 
$sql = "drop table if exists chkdb_idxs "; 
$result = run_sql( $sql ); 
$sql = "drop table if exists chkdb_tmp "; 
$result = run_sql( $sql ); 
} 
} 
function start_html( ) { 
echo "<html> 
<head> 
<title>MySQL Database Analyiser</title> 
<META NAME='keywords' content='MySQL, Database analysis, performance, tune'> 
<META NAME='description' content='Analyise your MySQL database for improve performance, " . 
"naming standards and security'>" . 
'<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' . "\n" . 
'<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">' . "\n" . 
"<STYLE TYPE='text/css'> 
<!-- 
TEXTAREA, SELECT, OPTION, INPUT { 
color: #000080; 
background-color: #FFFF99; 
} 
</STYLE>\n 
</head>" ; 
echo "<body link=#3333FF alink=#3333FF vlink=#3333FF bgcolor=#CCCC99> 
<center>\n"; 
} 
function show_title( ) { 
GLOBAL $prog; 
GLOBAL $db_server; 
GLOBAL $db_part; 
GLOBAL $db; 
GLOBAL $db_server; 
GLOBAL $db_user; 
GLOBAL $db_pwd; 
GLOBAL $matching; 
GLOBAL $mode; 
GLOBAL $time_started; 
$tab = get_param( 'tab' ); 
$col = get_param( 'col' ); 
$txt = ""; 
echo "<center><font size=+3> 
<a href=http://www.checkmypages.com/mysql_check> 
MySQL Database Analysis (0.2b) 
</a></font><p>  
<font size=+2> 
<a href=$prog?db_server=>Logout</a> &gt; \n"; 
if ( $db_part > '' ) { 
echo " Database <a href=$prog>$db_part</a> &gt; \n"; 
$txt = "$db_part > $matching > "; 
} 
if ( $matching > '' ) { 
echo "Restricted to <a href=$prog?db='$db_part::'>$matching</a> &gt; \n"; 
} 
if ( $tab > '' ) { 
echo "Table <a href=$prog?db=$db&$matching&tab=$tab>$tab</a>\n"; 
$txt .= "table $tab"; 
} 
if ( $col > '' ) { 
echo "Column <a href=$prog?&db=$db&col=$col>$col</a>\n"; 
$txt .= "column $col"; 
} 
echo "</font>"; 
$rpt_time = date( 'Y-m-d H:i' ); 
#DEMO_LOG 
if ( $mode > "" and $tab == '' and $col == '' and ereg( '.*:', $db ) ) { 
$sql = "select count(*) 
from    information_schema.ROUTINES 
where	routine_schema = schema() 
and routine_name like '$matching%' "; 
$result = run_sql( $sql ); 
list( $num_sp ) = mysql_fetch_row( $result ); 
$sql = "select count(*), sum(table_rows) from chkdb_tabs"; 
$result = run_sql( $sql ); 
list( $num_tab,$num_rows ) = mysql_fetch_row( $result ); 
echo "<p><table><tr><td><i>There are $num_tab tables and $num_sp stored procedures"; 
if ( $matching > "" ) { echo " matching $matching"; } 
echo "<br>Contains approximately "; 
if ( $num_rows > 1000000 ) { 
printf( "%9.0d%s\n", ($num_rows/1000000) , "m" ); 
} elseif ( $num_rows > 1000 ) { 
printf( "%9.0d%s\n", ($num_rows/1000) , "k" ); 
} else { 
echo $num_rows; 
} 
$sql = "select  sum( 100 - priority ) / count( distinct table_name ) 
from    chkdb_out "; 
$result = run_sql( $sql ); 
list( $avg_scr ) = mysql_fetch_row( $result ); 
if ( $avg_scr < 200 ) { 
$scr = 75 + ( ( 200 - $avg_scr ) * 25 ) / 200; 
} elseif ( $avg_scr < 300 ) { 
$scr = 50 + ( ( 300 - $avg_scr ) * 50 ) / 300; 
} else { 
$scr = 25 + ( ( 600 - $avg_scr ) * 75 ) / 600; 
} 
printf( " records<br>With an overall score of %3.0d%s\n", $scr, '%' ); 
$t = time() - $time_started; 
echo "<br>Report took $t seconds to run"; 
echo "</i></td></tr></table>\n"; 
} 
echo "<table width=700><tr><td>\n"; 
} 
function show_table( $name ) { 
$sql = "select * from $name"; 
$result = run_sql( $sql ); 
echo "<table border=1>"; 
while( $row = mysql_fetch_array( $result,MYSQL_ASSOC ) ) { 
echo "<tr>"; 
foreach( array_keys( $row ) as $d ) { 
echo "<td>" . $row[$d] . "</td>"; 
} 
echo "</tr>\n"; 
} 
echo "</table>"; 
} 
function get_session( $name ) { 
if( isset($_SESSION[$name]) ) { 
$tmp = $_SESSION[ $name ]; 
return $tmp; 
} else { 
return ""; 
} 
} 
?> 
